/****************************************************************************
**
** Copyright (C) 1992-2004 Trolltech AS. All rights reserved.
**
** This file is part of the compatibility classes of the Qt Toolkit.
**
** Licensees holding valid Qt Preview licenses may use this file in
** accordance with the Qt Preview License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef QWIDGETSTACK_H
#define QWIDGETSTACK_H

#include "qframe.h"

#ifndef QT_NO_WIDGETSTACK

class QWidgetStackPrivate;

class Q_COMPAT_EXPORT QWidgetStack : public QFrame
{
    Q_OBJECT
public:
    QWidgetStack(QWidget* parent=0, const char* name=0, Qt::WFlags f = 0);

    ~QWidgetStack();

    int addWidget(QWidget *, int = -1);
    void removeWidget(QWidget *);

    QSize sizeHint() const;
    QSize minimumSizeHint() const;
    void show();

    QWidget * widget(int) const;
    int id(QWidget *) const;

    QWidget * visibleWidget() const;

    void setMargin(int);
    int margin() const;

    QRect contentsRect() const;

signals:
    void aboutToShow(int);
    void aboutToShow(QWidget *);

public slots:
    void raiseWidget(int);
    void raiseWidget(QWidget *);

protected:
    void resizeEvent(QResizeEvent *);

    void setChildGeometries();
    void childEvent(QChildEvent *);
    bool event(QEvent *);

    QWidgetStackPrivate * d;

private:
    Q_DISABLE_COPY(QWidgetStack)
};

#endif // QT_NO_WIDGETSTACK

#endif // QWIDGETSTACK_H
